'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _create = require('babel-runtime/core-js/object/create');

var _create2 = _interopRequireDefault(_create);

exports.default = createExtendable;

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _searchParentConstructorEntry = require('./searchParentConstructorEntry');

var _searchParentConstructorEntry2 = _interopRequireDefault(_searchParentConstructorEntry);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var emptySymbol = 'empty';
var unwrappedMethods = ['constructor', 'get', 'getIn', 'first', 'last', 'reduce', 'reduceRight', 'find', 'findLast', 'findEntry', 'findLastEntry', 'max', 'maxBy', 'min', 'minBy'];

function createExtendable(base, copy, empty) {
  (0, _invariant2.default)(typeof copy === 'function', name + ': `copy` is expected to be a function.');
  (0, _invariant2.default)(typeof empty === 'function', name + ': `empty` is expected to be a function.');

  var name = base.prototype.constructor.name;
  var proto = (0, _create2.default)(base.prototype);

  // A method for wrapping an immutable object, with reference equality for empty objects
  proto.__wrapImmutable = function __wrapImmutable(val) {
    var forceCreation = arguments.length <= 1 || arguments[1] === undefined ? false : arguments[1];

    var prototype = (0, _getPrototypeOf2.default)(this);
    var constructor = prototype.constructor;


    if (!forceCreation && !val.size && !val.__ownerID) {
      if (!constructor[emptySymbol] || (0, _searchParentConstructorEntry2.default)(constructor, emptySymbol, constructor[emptySymbol])) {
        constructor[emptySymbol] = empty((0, _create2.default)(prototype));
      }

      return constructor[emptySymbol];
    }

    return copy((0, _create2.default)(prototype), val);
  };

  // Methods which will yield a Map and have to be wrapped before returning a result
  for (var key in base.prototype) {
    if (base.prototype.hasOwnProperty(key) && !key.startsWith('__') && !key.startsWith('to') && unwrappedMethods.indexOf(key) === -1) {
      (function () {
        var _originalMethod = base.prototype[key];

        if (typeof _originalMethod === 'function') {
          proto[key] = function wrappedMethod() {
            for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
              args[_key] = arguments[_key];
            }

            var res = _originalMethod.apply(this, args);
            var constructor = (0, _getPrototypeOf2.default)(res).constructor;

            if (res && (typeof res === 'undefined' ? 'undefined' : (0, _typeof3.default)(res)) === 'object' && constructor === base.prototype.constructor) {
              return this.__wrapImmutable(res);
            }

            return res;
          };
        }
      })();
    }
  }

  proto.__ensureOwner = function __ensureOwner(ownerID) {
    if (ownerID === this.__ownerID) {
      return this;
    } else if (!ownerID) {
      this.__ownerID = undefined;
      this.__altered = false;
      return this;
    }

    var res = this.__wrapImmutable(this, true);
    res.__ownerID = ownerID;
    return res;
  };

  return proto;
}